require 'csv'
require_relative './array'
module Flexa
  class Invoice
    def initialize(csv_file)
      @csv = self.parse(csv_file)
    end
    def parse(csv_file)
      csv = CSV.read(csv_file, headers: true, converters: :numeric)
      csv.each
    end

    def self.define_filter(name)
      hash = {
        amazonec2: 'AmazonEC2',
        amazonses: 'AmazonSES',
        amazonsns: 'AmazonSNS',
        amazonrds: 'AmazonRDS',
        amazons3: 'AmazonS3',
        amazonroute53: 'AmazonRoute53',
        awsdatatransfer: 'AWSDataTransfer',
        awsqueueservice: 'AWSQueueService'
      }
      define_method(name){ |client|
        @csv.find_all { |row| row['ProductCode'] == hash[name.to_sym] && row['user:Cliente'] == client }
      }
    end

    def total(who, client)
      total = 0
      self.send(who, client).each{ |row| total += row['TotalCost'] }
      total.round(2)
    end

    define_filter :amazonec2
    define_filter :amazonses
    define_filter :awsdatatransfer
    define_filter :amazonsns
    define_filter :amazonrds
    define_filter :amazons3
    define_filter :amazonroute53
    define_filter :awsqueueservice
  end
end
